This sample demonstrates how you can implement multi-point selection on a FlexChart control. Dragging on the chart will clear the currently selected points and select a new set of points that lie within the drag area. clicking on a point will also toggle its selection state, while clicking on an empty portion of the chart will clear the current selection.
loading...import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjChart from '@mescius/wijmo.chart';
import * as wijmo from '@mescius/wijmo';
import { getData } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let rendered = false, wjSelected = 'wj-state-selected', selections = [], mouseDown = false, start = null, end = null, selector = null, offset = null, mousePt = null, isTouch = false, items = [];
//
// create the chart
let chart = new wjChart.FlexChart('#theChart', {
chartType: 'Scatter',
axisY: {
axisLine: true
},
legend: {
position: 'None'
},
series: [
{
name: 'Experiment 1',
itemsSource: getData(50, 0, 3),
bindingX: 'x',
binding: 'y'
},
{
name: 'Experiment 2',
itemsSource: getData(40, 100, 12),
bindingX: 'x',
binding: 'y'
},
{
name: 'Experiment 3',
itemsSource: getData(30, -100, 24),
bindingX: 'x',
binding: 'y'
}
],
rendered: (sender) => {
if (!rendered) {
sender.hostElement.addEventListener('mousedown', chartMouseDown);
sender.hostElement.addEventListener('mousemove', chartMouseMove);
sender.hostElement.addEventListener('mouseup', chartMouseUp);
sender.hostElement.addEventListener('mouseleave', chartMouseLeave);
sender.hostElement.addEventListener('click', chartClick);
window.addEventListener('touchstart', () => isTouch = true, false);
//
// boolean flag - don't re-add event listener after resize
rendered = true;
//
selector = document.querySelector('#plotSelection');
sender.hostElement.appendChild(selector);
}
else {
// *visually* restore selection after redraw (ex. resize browser, change chart type)
restoreSelection();
}
}
});
//
// helper for clearing chart selection
function clearSelection() {
selections.forEach(item => {
let series = item.series, el = series.getPlotElement(item.pointIndex);
//
if (el) {
wijmo.removeClass(el, wjSelected);
}
});
//
selections.length = 0;
}
//
// helper for adding chart selection
function addSelection(obj) {
wijmo.addClass(obj.series.getPlotElement(obj.pointIndex), wjSelected);
//
selections.push({
series: obj.series,
pointIndex: obj.pointIndex
});
}
//
// helper for removing chart selection
function removeSelection(ht) {
let items = selections.filter(item => item.series === ht.series && item.pointIndex === ht.pointIndex), idx = items && items.length > 0 ? selections.indexOf(items[0]) : -1;
//
if (idx >= 0) {
selections.splice(idx, 1);
wijmo.removeClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
}
}
//
// finds selected plot elements after rendering and applies CSS to
// visually represent selection
function restoreSelection() {
selections.forEach(item => {
let series = item.series, el = series.getPlotElement(item.pointIndex);
//
if (el) {
wijmo.addClass(el, wjSelected);
}
});
}
//
// helper to hide the selector
function hideSelector() {
wijmo.setCss(selector, {
'visibility': 'hidden',
'width': 0,
'height': 0,
'left': 0,
'top': 0
});
}
//
// selects plot elements within drawn rectangle
function selectWithinRect(rect) {
if (!rect || !chart) {
return;
}
//
chart.series.forEach((item) => {
let pointCount = item._getLength();
//
for (let j = 0; j < pointCount; j++) {
let el = item.getPlotElement(j);
//
if (elementInBounds(el, rect)) {
addSelection({
series: item,
pointIndex: j
});
}
}
});
}
//
// helper to determine if plot element is within the bounds
// of the drawn rectangle
function elementInBounds(el, rect) {
let box = el.getBoundingClientRect();
return !(box.left > rect.right || box.right < rect.left || box.top > rect.bottom || box.bottom < rect.top);
}
//
// clear selection for button click
function clear() {
clearSelection();
// update length for view
items.length = 0;
}
//
function chartClick(e) {
if (mouseDown && !isTouch) {
isTouch = false;
return;
}
//
let p = wijmo.mouseToPage(e);
if (mousePt.x !== p.x || mousePt.y !== p.y) {
return;
}
//
let element = e.target, ht = chart.hitTest(e), selected = false, chartType = chart.chartType;
//
selected = selections.some(function (item) {
return item.series === ht.series && item.pointIndex === ht.pointIndex;
});
//
if (ht && ht.series && !selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouch) {
// remove selection
if (wijmo.hasClass(element, wjSelected)) {
removeSelection(ht);
}
// add selection
else {
addSelection(ht);
}
}
else if (selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouch) {
removeSelection(ht);
}
else {
clearSelection();
}
//
isTouch = false;
// update length for view
items.length = 0;
items.push.apply(items, selections);
}
//
function chartMouseDown(e) {
mousePt = wijmo.mouseToPage(e);
mouseDown = true;
e.preventDefault();
}
//
function chartMouseUp(e) {
if (start != null) {
start = null;
}
//
if (end != null) {
let host = chart.hostElement;
offset = wijmo.getElementRect(host);
//
let style = host.getAttribute('style');
offset.left = offset.left + parseInt(style ? style['padding-left'].replace('px', '') : 0);
offset.top = offset.top + parseInt(style ? style['padding-top'].replace('px', '') : 0);
//
end = start = null;
//
clear();
selectWithinRect(selector.getBoundingClientRect());
//
// update length for view
items.length = 0;
items.push.apply(items, selections);
//
e.preventDefault();
}
//
hideSelector();
mouseDown = false;
}
//
function chartMouseMove(e) {
let p = wijmo.mouseToPage(e);
if (!mouseDown || (mousePt.x == p.x && mousePt.y == p.y)) {
return;
}
//
let pt = e instanceof MouseEvent ? new wijmo.Point(e.pageX, e.pageY) : new wijmo.Point(e.changedTouches[0].pageX, e.changedTouches[0].pageY);
//
if (start != null) {
end = pt;
//
// update selector rectangle
let w = pt.x - start.x, h = pt.y - start.y;
//
if (w >= 0) {
wijmo.setCss(selector, {
'left': start.x - offset.left,
'width': w
});
}
else {
wijmo.setCss(selector, {
'left': pt.x - offset.left,
'width': -w
});
}
//
if (h >= 0) {
wijmo.setCss(selector, {
'top': start.y - offset.top,
'height': h
});
}
else {
wijmo.setCss(selector, {
'top': pt.y - offset.top,
'height': -h
});
}
}
else {
wijmo.setCss(selector, {
'visibility': 'visible'
});
offset = wijmo.getElementRect(selector);
//
start = pt;
}
//
e.preventDefault();
}
//
function chartMouseLeave(e) {
if (start) {
start = end = null;
mouseDown = false;
hideSelector();
}
}
}
Submit and view feedback for

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjChart from '@mescius/wijmo.chart';
import * as wjCore from '@mescius/wijmo';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { DataService } from './app.data';
//
const wjSelected: string = 'wj-state-selected';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjChartModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
@ViewChild('flexChart', { static: true }) chart: wjChart.FlexChart;
series1: any[];
series2: any[];
series3: any[];
private _rendered: boolean = false;
private _selections: {
series: wjChart.SeriesBase;
pointIndex: number;
}[] = [];
private _mouseDown: boolean = false;
private _start: wjCore.Point = null;
private _end: wjCore.Point = null;
private _selector: HTMLElement = null;
private _offset: wjCore.Rect = null;
private _mousePt: wjCore.Point = null;
private _isTouch: boolean = false;
private _items: {
series: wjChart.SeriesBase;
pointIndex: number;
}[] = [];
//
constructor(@Inject(DataService) private dataService: DataService) {
this.series1 = dataService.getData(50, 0, 3);
this.series2 = dataService.getData(40, 100, 12);
this.series3 = dataService.getData(30, -100, 24);
}
//
renderedEventHandler(flexChart: wjChart.FlexChart) {
if (!this._rendered) {
flexChart.hostElement.addEventListener('mousedown', this._chartMouseDown.bind(this));
flexChart.hostElement.addEventListener('mousemove', this._chartMouseMove.bind(this));
flexChart.hostElement.addEventListener('mouseup', this._chartMouseUp.bind(this));
flexChart.hostElement.addEventListener('mouseleave', this._chartMouseLeave.bind(this));
flexChart.hostElement.addEventListener('click', this._chartClick.bind(this));
window.addEventListener('touchstart', () => (this._isTouch = true), false);
//
// boolean flag - don't re-add event listener after resize
this._rendered = true;
//
this._selector = document.querySelector('#plotSelection');
flexChart.hostElement.appendChild(this._selector);
} else {
// *visually* restore selection after redraw (ex. resize browser, change chart type)
this._restoreSelection();
}
}
//
// helper for clearing chart selection
private _clearSelection() {
this._selections.forEach((item) => {
let series = item.series,
el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.removeClass(el, wjSelected);
}
});
//
this._selections.length = 0;
}
//
// helper for adding chart selection
private _addSelection(ht: any) {
wjCore.addClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
this._selections.push({
series: ht.series,
pointIndex: ht.pointIndex,
});
}
//
// helper for removing chart selection
private _removeSelection(ht: any) {
let items = this._selections.filter((item) => item.series === ht.series && item.pointIndex === ht.pointIndex),
idx = items && items.length > 0 ? this._selections.indexOf(items[0]) : -1;
//
if (idx >= 0) {
this._selections.splice(idx, 1);
wjCore.removeClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
}
}
//
// finds selected plot elements after rendering and applies CSS to visually represent selection
private _restoreSelection() {
this._selections.forEach((item) => {
let series = item.series,
el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.addClass(el, wjSelected);
}
});
}
//
// helper to hide the selector
private _hideSelector() {
wjCore.setCss(this._selector, {
visibility: 'hidden',
width: 0,
height: 0,
left: 0,
top: 0,
});
}
//
// selects plot elements within drawn rectangle
private _selectWithinRect(rect: ClientRect) {
if (!rect || !this.chart) {
return;
}
//
this.chart.series.forEach((item: wjChart.SeriesBase) => {
let pointCount = item._getLength();
//
for (let j = 0; j < pointCount; j++) {
let el = item.getPlotElement(j);
//
if (this._elementInBounds(el, rect)) {
this._addSelection({
series: item,
pointIndex: j,
});
}
}
});
}
//
// helper to determine if plot element is within the bounds of the drawn rectangle
private _elementInBounds(el: HTMLElement, rect: ClientRect) {
let box = el.getBoundingClientRect();
return !(box.left > rect.right || box.right < rect.left || box.top > rect.bottom || box.bottom < rect.top);
}
//
// clear selection for button click
private _clear() {
this._clearSelection();
// update length for view
this._items.length = 0;
}
//
private _chartClick(e: MouseEvent) {
if (this._mouseDown && !this._isTouch) {
this._isTouch = false;
return;
}
//
let p = wjCore.mouseToPage(e);
if (this._mousePt.x !== p.x || this._mousePt.y !== p.y) {
return;
}
//
let element = <HTMLElement>e.target,
ht = this.chart.hitTest(e),
selected = false,
chartType = this.chart.chartType;
//
selected = this._selections.some((item: any) => {
return item.series === ht.series && item.pointIndex === ht.pointIndex;
});
//
if (
ht &&
ht.series &&
!selected &&
((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) &&
this._isTouch
) {
// remove selection
if (wjCore.hasClass(element, wjSelected)) {
this._removeSelection(ht);
} else {
// add selection
this._addSelection(ht);
}
} else if (
selected &&
((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) &&
this._isTouch
) {
this._removeSelection(ht);
} else {
this._clearSelection();
}
//
this._isTouch = false;
// update length for view
this._items.length = 0;
this._items.push.apply(this._items, this._selections);
}
//
private _chartMouseDown(e: MouseEvent) {
this._mousePt = wjCore.mouseToPage(e);
this._mouseDown = true;
e.preventDefault();
}
//
private _chartMouseUp(e: MouseEvent) {
if (this._start != null) {
this._start = null;
}
//
if (this._end != null) {
let host = this.chart.hostElement;
this._offset = wjCore.getElementRect(host);
let style = host.getAttribute('style');
this._offset.left = this._offset.left + parseInt(style ? style['padding-left'].replace('px', '') : 0);
this._offset.top = this._offset.top + parseInt(style ? style['padding-top'].replace('px', '') : 0);
//
this._end = this._start = null;
//
this._clear();
this._selectWithinRect(this._selector.getBoundingClientRect());
//
// update length for view
this._items.length = 0;
this._items.push.apply(this._items, this._selections);
//
e.preventDefault();
}
//
this._hideSelector();
this._mouseDown = false;
}
//
private _chartMouseMove(e: MouseEvent | TouchEvent) {
let p = wjCore.mouseToPage(e);
if (!this._mouseDown || (this._mousePt.x == p.x && this._mousePt.y == p.y)) {
return;
}
//
let pt =
e instanceof MouseEvent
? new wjCore.Point(e.pageX, e.pageY)
: new wjCore.Point(e.changedTouches[0].pageX, e.changedTouches[0].pageY);
//
if (this._start != null) {
this._end = pt;
//
// update selector rectangle
let w = pt.x - this._start.x;
let h = pt.y - this._start.y;
//
if (w >= 0) {
wjCore.setCss(this._selector, {
left: this._start.x - this._offset.left,
width: w,
});
} else {
wjCore.setCss(this._selector, {
left: pt.x - this._offset.left,
width: -w,
});
}
//
if (h >= 0) {
wjCore.setCss(this._selector, {
top: this._start.y - this._offset.top,
height: h,
});
} else {
wjCore.setCss(this._selector, {
top: pt.y - this._offset.top,
height: -h,
});
}
} else {
wjCore.setCss(this._selector, {
visibility: 'visible',
});
this._offset = wjCore.getElementRect(this._selector);
//
this._start = pt;
}
//
e.preventDefault();
}
//
private _chartMouseLeave(e: MouseEvent) {
if (this._start) {
this._start = this._end = null;
this._mouseDown = false;
this._hideSelector();
}
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Select Box</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div id="plotSelection"></div>
<wj-flex-chart #flexChart [chartType]="'Scatter'" [bindingX]="'x'" (rendered)="renderedEventHandler(flexChart)">
<wj-flex-chart-axis wjProperty="axisY" [axisLine]="true">
</wj-flex-chart-axis>
<wj-flex-chart-legend [position]="'None'">
</wj-flex-chart-legend>
<wj-flex-chart-series [name]="'Experiment 1'" [itemsSource]="series1" [bindingX]="'x'" [binding]="'y'">
</wj-flex-chart-series>
<wj-flex-chart-series [name]="'Experiment 2'" [itemsSource]="series2" [bindingX]="'x'" [binding]="'y'">
</wj-flex-chart-series>
<wj-flex-chart-series [name]="'Experiment 3'" [itemsSource]="series3" [bindingX]="'x'" [binding]="'y'">
</wj-flex-chart-series>
</wj-flex-chart>
</div>
import { Injectable } from '@angular/core';
//
@Injectable()
export class DataService {
getData(cnt: number, a: number, b: number) {
let arr = [],
x = -5 * cnt / 2;
//
for (let i = 0; i < cnt; i++) {
let rnd = Math.random() * cnt - cnt / 2;
//
arr.push({
x: x,
y: a + x * (b + rnd) + rnd
});
//
x += .5 + Math.random() * 10;
}
//
return arr;
}
}
.wj-flexchart {
height: 600px;
width: 600px;
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
#plotSelection {
background-color:rgba(85, 85, 85, 0.05);
border:2px dashed #808080;
position:absolute;
display:block;
left:0;
top:0;
pointer-events:none;
visibility: hidden;
}
.wj-flexchart .wj-state-selected {
stroke-width: 20px;
stroke-dasharray: none;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import * as wjCore from '@mescius/wijmo';
import * as wjChart from '@mescius/wijmo.react.chart';
import './app.css';
import { getData } from './data';
const wjSelected = 'wj-state-selected';
function App() {
const [series1] = useState(getData(50, 0, 3));
const [series2] = useState(getData(40, 100, 12));
const [series3] = useState(getData(30, -100, 24));
const renderedRef = useRef(false);
const selectionsRef = useRef([]);
const mouseDownRef = useRef(false);
const startRef = useRef(null);
const endRef = useRef(null);
const selectorRef = useRef(null);
const offsetRef = useRef(null);
const mousePtRef = useRef(null);
const isTouchRef = useRef(false);
const itemsRef = useRef([]);
const chartRef = useRef(null);
const chartInitialized = (sender) => {
chartRef.current = sender;
};
const chartRendered = (sender) => {
if (!renderedRef.current) {
sender.hostElement.addEventListener('mousedown', $_chartMouseDown);
sender.hostElement.addEventListener('mousemove', $_chartMouseMove);
sender.hostElement.addEventListener('mouseup', $_chartMouseUp);
sender.hostElement.addEventListener('mouseleave', $_chartMouseLeave);
sender.hostElement.addEventListener('click', $_chartClick);
window.addEventListener('touchstart', () => isTouchRef.current = true, false);
//
// boolean flag - don't re-add event listener after resize
renderedRef.current = true;
//
selectorRef.current = document.querySelector('#plotSelection');
sender.hostElement.appendChild(selectorRef.current);
}
else {
// *visually* restore selection after redraw (ex. resize browser, change chart type)
$_restoreSelection();
}
};
const $_clearSelection = () => {
selectionsRef.current.forEach((item) => {
let series = item.series, el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.removeClass(el, wjSelected);
}
});
//
selectionsRef.current.length = 0;
};
// helper for adding chart selection
const $_addSelection = (ht) => {
wjCore.addClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
selectionsRef.current.push({
series: ht.series,
pointIndex: ht.pointIndex
});
};
// helper for removing chart selection
const $_removeSelection = (ht) => {
let items = selectionsRef.current.filter((item) => item.series === ht.series && item.pointIndex === ht.pointIndex), idx = items && items.length > 0 ? selectionsRef.current.indexOf(items[0]) : -1;
//
if (idx >= 0) {
selectionsRef.current.splice(idx, 1);
wjCore.removeClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
}
};
// finds selected plot elements after rendering and applies CSS to visually represent selection
const $_restoreSelection = () => {
selectionsRef.current.forEach((item) => {
let series = item.series, el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.addClass(el, wjSelected);
}
});
};
// helper to hide the selector
const $_hideSelector = () => {
wjCore.setCss(selectorRef.current, {
'visibility': 'hidden',
'width': 0,
'height': 0,
'left': 0,
'top': 0
});
};
// selects plot elements within drawn rectangle
const $_selectWithinRect = (rect) => {
if (!rect || !chartRef.current) {
return;
}
//
chartRef.current.series.forEach((item) => {
let pointCount = item._getLength();
//
for (let j = 0; j < pointCount; j++) {
let el = item.getPlotElement(j);
//
if ($_elementInBounds(el, rect)) {
$_addSelection({
series: item,
pointIndex: j
});
}
}
});
};
// helper to determine if plot element is within the bounds of the drawn rectangle
const $_elementInBounds = (el, rect) => {
let box = el.getBoundingClientRect();
return !(box.left > rect.right || box.right < rect.left || box.top > rect.bottom || box.bottom < rect.top);
};
// clear selection for button click
const $_clear = () => {
$_clearSelection();
// update length for view
itemsRef.current.length = 0;
};
const $_chartClick = (e) => {
if (mouseDownRef.current && !isTouchRef.current) {
isTouchRef.current = false;
return;
}
//
let p = wjCore.mouseToPage(e);
if (mousePtRef.current.x !== p.x || mousePtRef.current.y !== p.y) {
return;
}
//
let element = e.target, ht = chartRef.current.hitTest(e), selected = false, chartType = chartRef.current.chartType;
//
selected = selectionsRef.current.some((item) => {
return item.series === ht.series && item.pointIndex === ht.pointIndex;
});
//
if (ht && ht.series && !selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouchRef.current) {
// remove selection
if (wjCore.hasClass(element, wjSelected)) {
$_removeSelection(ht);
}
else {
// add selection
$_addSelection(ht);
}
}
else if (selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouchRef.current) {
$_removeSelection(ht);
}
else {
$_clearSelection();
}
//
isTouchRef.current = false;
// update length for view
itemsRef.current.length = 0;
itemsRef.current.push.apply(itemsRef.current, selectionsRef.current);
};
const $_chartMouseDown = (e) => {
mousePtRef.current = wjCore.mouseToPage(e);
mouseDownRef.current = true;
e.preventDefault();
};
const $_chartMouseUp = (e) => {
var _a;
if (startRef.current != null) {
startRef.current = null;
}
//
if (endRef.current != null) {
let host = chartRef.current.hostElement;
offsetRef.current = wjCore.getElementRect(host);
let style = host.getAttribute('style');
offsetRef.current.left = offsetRef.current.left + parseInt(style ? style['padding-left'].replace('px', '') : 0);
offsetRef.current.top = offsetRef.current.top + parseInt(style ? style['padding-top'].replace('px', '') : 0);
//
endRef.current = startRef.current = null;
//
$_clear();
$_selectWithinRect((_a = selectorRef.current) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect());
//
// update length for view
itemsRef.current.length = 0;
itemsRef.current.push.apply(itemsRef.current, selectionsRef.current);
//
e.preventDefault();
}
//
$_hideSelector();
mouseDownRef.current = false;
};
const $_chartMouseMove = (e) => {
let p = wjCore.mouseToPage(e);
if (!mouseDownRef.current || (mousePtRef.current.x == p.x && mousePtRef.current.y == p.y)) {
return;
}
//
let pt = e instanceof MouseEvent ? new wjCore.Point(e.pageX, e.pageY) : new wjCore.Point(e.changedTouches[0].pageX, e.changedTouches[0].pageY);
//
if (startRef.current != null) {
endRef.current = pt;
// update selector rectangle
let w = pt.x - startRef.current.x;
let h = pt.y - startRef.current.y;
//
if (w >= 0) {
wjCore.setCss(selectorRef.current, {
'left': startRef.current.x - offsetRef.current.left,
'width': w
});
}
else {
wjCore.setCss(selectorRef.current, {
'left': pt.x - offsetRef.current.left,
'width': -w
});
}
if (h >= 0) {
wjCore.setCss(selectorRef.current, {
'top': startRef.current.y - offsetRef.current.top,
'height': h
});
}
else {
wjCore.setCss(selectorRef.current, {
'top': pt.y - offsetRef.current.top,
'height': -h
});
}
}
else {
wjCore.setCss(selectorRef.current, {
'visibility': 'visible'
});
if (selectorRef.current) {
offsetRef.current = wjCore.getElementRect(selectorRef.current);
}
startRef.current = pt;
}
e.preventDefault();
};
const $_chartMouseLeave = (e) => {
if (startRef.current) {
startRef.current = endRef.current = null;
mouseDownRef.current = false;
$_hideSelector();
}
};
return (<div className="container-fluid">
<div id="plotSelection"></div>
<wjChart.FlexChart chartType="Scatter" bindingX="x" initialized={chartInitialized} rendered={chartRendered}>
<wjChart.FlexChartAxis wjProperty="axisY" axisLine={true}/>
<wjChart.FlexChartLegend position="None"/>
<wjChart.FlexChartSeries name="Experiment 1" itemsSource={series1} bindingX="x" binding="y">
</wjChart.FlexChartSeries>
<wjChart.FlexChartSeries name="Experiment 2" itemsSource={series2} bindingX="x" binding="y">
</wjChart.FlexChartSeries>
<wjChart.FlexChartSeries name="Experiment 3" itemsSource={series3} bindingX="x" binding="y">
</wjChart.FlexChartSeries>
</wjChart.FlexChart>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexChart Select Box</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexchart {
height: 600px;
width: 600px;
margin: 10px 0;
}
#plotSelection {
background-color: rgba(85, 85, 85, 0.05);
border: 2px dashed #808080;
position: absolute;
display: block;
left: 0;
top: 0;
pointer-events: none;
visibility: hidden;
}
.wj-flexchart .wj-state-selected {
stroke-width: 20px;
stroke-dasharray: none;
}
export function getData(cnt, a, b) {
let arr = [], x = -5 * cnt / 2;
//
for (let i = 0; i < cnt; i++) {
let rnd = Math.random() * cnt - cnt / 2;
//
arr.push({
x: x,
y: a + x * (b + rnd) + rnd
});
//
x += .5 + Math.random() * 10;
}
//
return arr;
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div id="plotSelection"></div>
<wj-flex-chart chartType="Scatter" bindingX="x" :initialized="chartInitialized" :rendered="chartRendered">
<wj-flex-chart-axis wjProperty="axisY" :axisLine=true>
</wj-flex-chart-axis>
<wj-flex-chart-legend position="None">
</wj-flex-chart-legend>
<wj-flex-chart-series name="Experiment 1" :itemsSource="series1" bindingX="x" binding="y">
</wj-flex-chart-series>
<wj-flex-chart-series name="Experiment 2" :itemsSource="series2" bindingX="x" binding="y">
</wj-flex-chart-series>
<wj-flex-chart-series name="Experiment 3" :itemsSource="series3" bindingX="x" binding="y">
</wj-flex-chart-series>
</wj-flex-chart>
</div>
</template>
<script setup>
import * as wjCore from "@mescius/wijmo";
import { getData } from "./data";
import { ref } from "vue";
const series1 = ref(getData(50, 0, 3));
const series2 = ref(getData(40, 100, 12));
const series3 = ref(getData(30, -100, 24));
const rendered = ref(null);
const mouseDown = ref(null);
const mousePt = ref(null);
const isTouch = ref(null);
const selector = ref(null);
const selections = ref(null);
const start = ref(null);
const end = ref(null);
const offset = ref(null);
const items = ref(null);
const chart = ref(null);
const wjSelected = 'wj-state-selected';
function chartInitialized(sender) {
rendered.value = false;
mouseDown.value = false;
mousePt.value = null;
isTouch.value = false;
selector.value = null;
selections.value = [];
(start.value = null), (end.value = null);
offset.value = null;
items.value = [];
chart.value = sender;
}
function chartRendered(sender) {
if (!rendered.value) {
sender.hostElement.addEventListener("mousedown", $_chartMouseDown.bind(this));
sender.hostElement.addEventListener("mousemove", $_chartMouseMove.bind(this));
sender.hostElement.addEventListener("mouseup", $_chartMouseUp.bind(this));
sender.hostElement.addEventListener("mouseleave", $_chartMouseLeave.bind(this));
sender.hostElement.addEventListener("click", $_chartClick.bind(this));
window.addEventListener("touchstart", () => (isTouch.value = true), false);
//
// boolean flag - don't re-add event listener after resize
rendered.value = true;
//
selector.value = document.querySelector("#plotSelection");
sender.hostElement.appendChild(selector.value);
} else {
// *visually* restore selection after redraw (ex. resize browser, change chart type)
$_restoreSelection();
}
}
// helper for clearing chart selection
function $_clearSelection() {
selections.value.forEach((item) => {
let series = item.series,
el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.removeClass(el, wjSelected);
}
});
//
selections.value.length = 0;
}
// helper for adding chart selection
function $_addSelection(ht) {
wjCore.addClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
selections.value.push({
series: ht.series,
pointIndex: ht.pointIndex,
});
}
// helper for removing chart selection
function $_removeSelection(ht) {
let items = selections.value.filter((item) => item.series === ht.series && item.pointIndex === ht.pointIndex),
idx = items && items.length > 0 ? selections.value.indexOf(items[0]) : -1;
//
if (idx >= 0) {
selections.value.splice(idx, 1);
wjCore.removeClass(ht.series.getPlotElement(ht.pointIndex), wjSelected);
}
}
// finds selected plot elements after rendering and applies CSS to visually represent selection
function $_restoreSelection() {
selections.value.forEach((item) => {
let series = item.series,
el = series.getPlotElement(item.pointIndex);
//
if (el) {
wjCore.addClass(el, wjSelected);
}
});
}
// helper to hide the selector
function $_hideSelector() {
wjCore.setCss(selector.value, {
visibility: "hidden",
width: 0,
height: 0,
left: 0,
top: 0,
});
}
// selects plot elements within drawn rectangle
function $_selectWithinRect(rect) {
if (!rect || !chart.value) {
return;
}
//
chart.value.series.forEach((item) => {
let pointCount = item._getLength();
//
for (let j = 0; j < pointCount; j++) {
let el = item.getPlotElement(j);
//
if ($_elementInBounds(el, rect)) {
$_addSelection({
series: item,
pointIndex: j,
});
}
}
});
}
// helper to determine if plot element is within the bounds of the drawn rectangle
function $_elementInBounds(el, rect) {
let box = el.getBoundingClientRect();
return !(box.left > rect.right || box.right < rect.left || box.top > rect.bottom || box.bottom < rect.top);
}
// clear selection for button click
function $_clear() {
$_clearSelection();
// update length for view
items.value.length = 0;
}
function $_chartClick(e) {
if (mouseDown.value && !isTouch.value) {
isTouch.value = false;
return;
}
//
let p = wjCore.mouseToPage(e);
if (mousePt.value.x !== p.x || mousePt.value.y !== p.y) {
return;
}
//
let element = e.target,
ht = chart.value.hitTest(e),
selected = false,
chartType = chart.value.chartType;
//
selected = selections.value.some((item) => {
return item.series === ht.series && item.pointIndex === ht.pointIndex;
});
//
if (ht && ht.series && !selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouch.value) {
// remove selection
if (wjCore.hasClass(element, wjSelected)) {
$_removeSelection(ht);
} else {
// add selection
$_addSelection(ht);
}
} else if (selected && ((ht.distance <= 0 && (chartType == 0 || chartType == 1)) || ht.distance <= 15) && isTouch.value) {
$_removeSelection(ht);
} else {
$_clearSelection();
}
//
isTouch.value = false;
// update length for view
items.value.length = 0;
items.value.push.apply(items.value, selections.value);
}
function $_chartMouseDown(e) {
mousePt.value = wjCore.mouseToPage(e);
mouseDown.value = true;
e.preventDefault();
}
function $_chartMouseUp(e) {
if (start.value != null) {
start.value = null;
}
//
if (end.value != null) {
let host = chart.value.hostElement;
offset.value = wjCore.getElementRect(host);
let style = host.getAttribute("style");
offset.value.left = offset.value.left + parseInt(style ? style["padding-left"].replace("px", "") : 0);
offset.value.top = offset.value.top + parseInt(style ? style["padding-top"].replace("px", "") : 0);
//
end.value = start.value = null;
//
$_clear();
$_selectWithinRect(selector.value.getBoundingClientRect());
//
// update length for view
items.value.length = 0;
items.value.push.apply(items.value, selections.value);
//
e.preventDefault();
}
//
$_hideSelector();
mouseDown.value = false;
}
function $_chartMouseMove(e) {
let p = wjCore.mouseToPage(e);
if (!mouseDown.value || (mousePt.value.x == p.x && mousePt.value.y == p.y)) {
return;
}
//
let pt = e instanceof MouseEvent ? new wjCore.Point(e.pageX, e.pageY) : new wjCore.Point(e.changedTouches[0].pageX, e.changedTouches[0].pageY);
//
if (start.value != null) {
end.value = pt;
//
// update selector rectangle
let w = pt.x - start.value.x;
let h = pt.y - start.value.y;
//
if (w >= 0) {
wjCore.setCss(selector.value, {
left: start.value.x - offset.value.left,
width: w,
});
} else {
wjCore.setCss(selector.value, {
left: pt.x - offset.value.left,
width: -w,
});
}
//
if (h >= 0) {
wjCore.setCss(selector.value, {
top: start.value.y - offset.value.top,
height: h,
});
} else {
wjCore.setCss(selector.value, {
top: pt.y - offset.value.top,
height: -h,
});
}
} else {
wjCore.setCss(selector.value, {
visibility: "visible",
});
offset.value = wjCore.getElementRect(selector.value);
//
start.value = pt;
}
//
e.preventDefault();
}
function $_chartMouseLeave(e) {
if (start.value) {
start.value = end.value = null;
mouseDown.value = false;
$_hideSelector();
}
}
</script>
<style>
.container-fluid .wj-flexchart {
height: 600px;
width: 600px;
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
#plotSelection {
background-color: rgba(85, 85, 85, 0.05);
border: 2px dashed #808080;
position: absolute;
display: block;
left: 0;
top: 0;
pointer-events: none;
visibility: hidden;
}
.container-fluid .wj-flexchart .wj-state-selected {
stroke-width: 20px;
stroke-dasharray: none;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Select Box</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData(cnt, a, b) {
let arr = [],
x = -5 * cnt / 2;
//
for (let i = 0; i < cnt; i++) {
let rnd = Math.random() * cnt - cnt / 2;
//
arr.push({
x: x,
y: a + x * (b + rnd) + rnd
});
//
x += .5 + Math.random() * 10;
}
//
return arr;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);